Subject: Re: [PATCH 1/2]: pkt_sched: Convert qdisc_watchdog to tasklet_hrtimer

From: Jarek Poplawski <[email-masked]>
Date: Thu, 27 Aug 2009 08:36:41 +0000

On 22-08-2009 02:03, David Miller wrote:
> None of this stuff should execute in hw IRQ context, therefore
> use a tasklet_hrtimer so that it runs in softirq context.
> 
> Signed-off-by: David S. Miller <[email-masked]>
> ---
...
>  void qdisc_watchdog_cancel(struct qdisc_watchdog *wd)
>  {
> -	hrtimer_cancel(&wd->timer);
> +	tasklet_hrtimer_cancel(&wd->timer);
>  	wd->qdisc->flags &= ~TCQ_F_THROTTLED;
>  }
>  EXPORT_SYMBOL(qdisc_watchdog_cancel);

I've had a second look at it and I wonder why it's not reported, but
since qdisc_watchdog_cancel is run in qdisc_reset with BHs disabled
it seems there should be (at least) a warning triggered in
tasklet_kill on positive in_interrupt test (unless I miss something,
but can't test it now).

Jarek P.